Attribute VB_Name = "modRecycleBin"
Option Explicit

Public Enum rbEmptyBinEnum
  SHERB_NOCONFIRMATION = &H1
  SHERB_NOPROGRESSUI = &H2
  SHERB_NOSOUND = &H4
End Enum
Public Declare Function EmptyRecycleBin Lib "shell32" Alias "SHEmptyRecycleBinA" _
    (Optional ByVal hWnd As Long = 0, _
      Optional ByVal pszRootPath As String = vbNullString, _
      Optional ByVal dwFlags As rbEmptyBinEnum = 0) _
    As Long

Private Type SHQUERYRBINFO
  cbSize As Long
  i64Size As Currency
  i64NumItems As Currency
End Type
Private Declare Function SHQueryRecycleBin Lib "shell32" Alias "SHQueryRecycleBinA" _
    (ByVal pszRootPath As String, _
      pSHQueryRBInfo As SHQUERYRBINFO) _
    As Long

Public Sub QueryRecycleBin(Optional ByVal RootPath As String = vbNullString, _
                            Optional ByRef Size As Variant, _
                            Optional ByRef NumItems As Variant)
Dim pQRBI As SHQUERYRBINFO
  
  'Make sure variants are initialized to
  ' Decimal subtype (largest numeric)
  Size = CDec(0)
  NumItems = CDec(0)
  
  With pQRBI
    .cbSize = Len(pQRBI)
    
    SHQueryRecycleBin RootPath, _
                      pQRBI
    
    'The Currency data type is the only pure
    ' 64-bits numeric data type VB has, but
    ' it inserts a comma at the fourth
    ' position from the right...
    'Let's correct this!
    Size = .i64Size * 10000
    NumItems = .i64NumItems * 10000
  End With
End Sub
